# generated by datamodel-codegen:
#   filename:  model.json
#   timestamp: 2021-04-24T01:31:22+00:00

from __future__ import annotations

from datetime import date, datetime
from enum import Enum
from typing import Optional
from uuid import UUID

from pydantic import BaseModel, Field


class Status(Enum):
    employed = 'employed'
    terminated = 'terminated'
    furloughed = 'furloughed'


class Country(Enum):
    US = 'US'


class EmployerAddress(BaseModel):
    raw: str = Field(..., description='The raw address.', title='Raw')
    line1: Optional[str] = Field(
        None, description='The first line of the address.', title='Line1'
    )
    line2: Optional[str] = Field(
        None, description='The second line of the address.', title='Line2'
    )
    city: Optional[str] = Field(
        None, description='The city of the address.', title='City'
    )
    state: Optional[str] = Field(
        None, description='The state of the address.', title='State'
    )
    postal_code: Optional[str] = Field(
        None, description='The postal code of the address.', title='Postal Code'
    )
    country: Optional[Country] = Field(
        None, description='The country of the address.', title='Country'
    )


class Type(Enum):
    home = 'home'
    work = 'work'
    mobile = 'mobile'


class EmployerPhoneNumber(BaseModel):
    value: str = Field(
        ..., description='The E.164 formatted phone number.', title='Value'
    )
    type: Optional[Type] = Field(
        None, description='home, mobile, work, etc.', title='Type'
    )


class Employment(BaseModel):
    id: UUID = Field(..., description='Unique identifier for the object.', title='Id')
    created_at: datetime = Field(
        ..., description='ISO 8601 timestamp of created time.', title='Created At'
    )
    account_id: UUID = Field(
        ..., description='Unique identifier for the object.', title='Account Id'
    )
    status: Optional[Status] = Field(
        None, description='The employment status of the employee.', title='Status'
    )
    start_date: Optional[date] = Field(
        None, description='The date the employee began their job.', title='Start Date'
    )
    termination_date: Optional[date] = Field(
        None,
        description='The date the employee was terminated.',
        title='Termination Date',
    )
    employer_name: Optional[str] = Field(
        None,
        description='Name of employer, e.g., Apple, Disney, Walmart.',
        title='Employer Name',
    )
    employer_address: Optional[EmployerAddress] = Field(
        None, description='The address of the employer.', title='Employer Address'
    )
    employer_phone_number: Optional[EmployerPhoneNumber] = Field(
        None,
        description='The phone number of the employer.',
        title='Employer Phone Number',
    )
