# generated by datamodel-codegen:
#   filename:  model.json
#   timestamp: 2021-04-24T01:32:18+00:00

from __future__ import annotations

from datetime import datetime
from enum import Enum
from typing import List, Optional
from uuid import UUID

from pydantic import AnyUrl, BaseModel, Field, PositiveFloat


class SupportedJob(Enum):
    direct_deposit_switch = 'direct_deposit_switch'
    direct_deposit_payment = 'direct_deposit_payment'
    direct_deposit_allocations = 'direct_deposit_allocations'
    income = 'income'
    employment = 'employment'
    identity = 'identity'
    paystubs = 'paystubs'
    shifts = 'shifts'


class Platform(BaseModel):
    id: UUID = Field(..., description='UUID of the platform.', title='Id')
    name: str = Field(
        ...,
        description='Name of platform, e.g., ADP Portal, Gusto, Paylocity.',
        title='Name',
    )
    fractional_amount_supported: bool = Field(
        ...,
        description='Whether or not the platform accepts decimal values for `direct_deposit_switch` or `direct_deposit_payment`.',
        title='Fractional Amount Supported',
    )
    min_amount: Optional[PositiveFloat] = Field(
        None,
        description='Minimum amount, if any, platform accepts for `direct_deposit_switch` or `direct_deposit_payment`.',
        title='Min Amount',
    )
    max_amount: Optional[PositiveFloat] = Field(
        None,
        description='Maximum amount, if any, platform accepts for `direct_deposit_switch` or `direct_deposit_payment`.',
        title='Max Amount',
    )
    last_updated: datetime = Field(
        ...,
        description='ISO 8601 timestamp of the last update to this object.',
        title='Last Updated',
    )
    logo_url: Optional[AnyUrl] = Field(
        None, description='The URL of the platform logo.', title='Logo Url'
    )
    supported_jobs: List[SupportedJob] = Field(
        ..., description='Array of supported jobs.', title='Supported Jobs'
    )
    amount_supported: bool = Field(
        ...,
        description='Whether a direct deposit job supports specific amount.',
        title='Amount Supported',
    )
