# generated by datamodel-codegen:
#   filename:  model.json
#   timestamp: 2021-04-24T01:30:44+00:00

from __future__ import annotations

from datetime import datetime
from enum import Enum
from typing import List, Optional
from uuid import UUID

from pydantic import AnyUrl, BaseModel, Field


class SupportedJob(Enum):
    direct_deposit_switch = 'direct_deposit_switch'
    direct_deposit_payment = 'direct_deposit_payment'
    direct_deposit_allocations = 'direct_deposit_allocations'
    income = 'income'
    employment = 'employment'
    identity = 'identity'
    paystubs = 'paystubs'
    shifts = 'shifts'


class ResponseType(Enum):
    employer = 'employer'
    platform = 'platform'


class SearchResult(BaseModel):
    id: UUID = Field(..., description='Unique identifier for the object.', title='Id')
    name: str = Field(..., description='Name of result.', title='Name')
    last_updated: datetime = Field(
        ...,
        description='ISO 8601 timestamp of the last update to this object.',
        title='Last Updated',
    )
    logo_url: Optional[AnyUrl] = Field(
        None, description='The URL of the employer or platform logo.', title='Logo Url'
    )
    supported_jobs: List[SupportedJob] = Field(
        ..., description='Array of supported jobs.', title='Supported Jobs'
    )
    fractional_amount_supported: bool = Field(
        ...,
        description='Whether or not the platform accepts decimal values for `direct_deposit_switch` or `direct_deposit_payment`.',
        title='Fractional Amount Supported',
    )
    amount_supported: bool = Field(
        ...,
        description='Whether a direct deposit job supports specific amount.',
        title='Amount Supported',
    )
    min_amount: float = Field(
        ...,
        description='Minimum amount, if any, platform accepts for `direct_deposit_switch` or `direct_deposit_payment`.',
        title='Min Amount',
    )
    max_amount: float = Field(
        ...,
        description='Maximum amount, if any, platform accepts for `direct_deposit_switch` or `direct_deposit_payment`.',
        title='Max Amount',
    )
    response_type: ResponseType = Field(
        ...,
        description='Type of search result, either platform or employer.',
        title='Response Type',
    )
