# generated by datamodel-codegen:
#   filename:  model.json
#   timestamp: 2021-04-24T01:34:47+00:00

from __future__ import annotations

from datetime import datetime
from enum import Enum
from typing import List
from uuid import UUID

from pydantic import BaseModel, Field


class Status(Enum):
    active = 'active'
    paused = 'paused'


class EnabledEvent(Enum):
    _ = '*'
    direct_deposit_switch_added = 'direct_deposit_switch.added'
    direct_deposit_payment_added = 'direct_deposit_payment.added'
    direct_deposit_allocations_added = 'direct_deposit_allocations.added'
    account_added = 'account.added'
    employment_added = 'employment.added'
    income_added = 'income.added'
    identity_added = 'identity.added'
    paystubs_added = 'paystubs.added'
    shifts_added = 'shifts.added'


class Webhook(BaseModel):
    url: str = Field(..., description='The URL of the webhook endpoints.', title='Url')
    status: Status = Field(
        ..., description='The status of the webhook.', title='Status'
    )
    enabled_events: List[EnabledEvent] = Field(
        ...,
        description='The list of events enabled for this webhook.',
        min_items=1,
        title='Enabled Events',
    )
    id: UUID = Field(..., description='Unique identifier for the object.', title='Id')
    created_at: datetime = Field(
        ..., description='ISO 8601 timestamp of created time.', title='Created At'
    )
