# generated by datamodel-codegen:
#   filename:  model.json
#   timestamp: 2021-04-24T01:26:02+00:00

from __future__ import annotations

from enum import Enum
from typing import List

from pydantic import BaseModel, Field


class Status(Enum):
    active = 'active'
    paused = 'paused'


class EnabledEvent(Enum):
    _ = '*'
    direct_deposit_switch_added = 'direct_deposit_switch.added'
    direct_deposit_payment_added = 'direct_deposit_payment.added'
    direct_deposit_allocations_added = 'direct_deposit_allocations.added'
    account_added = 'account.added'
    employment_added = 'employment.added'
    income_added = 'income.added'
    identity_added = 'identity.added'
    paystubs_added = 'paystubs.added'
    shifts_added = 'shifts.added'


class WebhookPostBody(BaseModel):
    url: str = Field(
        ...,
        description="The URL of the webhook endpoints. Must be 'https://'.",
        title='Url',
    )
    status: Status = Field(
        ..., description='The status of the webhook.', title='Status'
    )
    enabled_events: List[EnabledEvent] = Field(
        ...,
        description='The list of events enabled for this webhook.',
        min_items=1,
        title='Enabled Events',
    )
